/*
 * Copyright (C) 2019  Kevin Whitaker <eyecreate@eyecreate.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIMPLECASTTCPSERVICE_H
#define SIMPLECASTTCPSERVICE_H

#include <QTcpServer>
#include <KDNSSD/DNSSD/PublicService>
#include "minimediaplayer.h"

/**
 * Tcp Server that responds to simple client requests and can be found over DNSSD.
 */
class SimpleCastTcpService : public QTcpServer
{
    Q_OBJECT

public:
    SimpleCastTcpService(MiniMediaPlayer *player,QObject *parent = 0);
    bool listen(const QHostAddress &address = QHostAddress::Any, quint16 port = 0);
    void close();
    
protected:
    void incomingConnection(qintptr handle) override;
    
private:
    MiniMediaPlayer *player;
    KDNSSD::PublicService *dnsService;

};

#endif // SIMPLECASTTCPSERVICE_H
